#! /usr/bin/env python
# coding: utf-8

"""
   This file is part of Paranoia auto-backup (paranoiaab).

Copyright (C) 2012   Juan Quiroga  < http://yojuan.com.ar/ >

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details. < http://gnu.org/licenses/ >
"""

# Author: Juan Quiroga
# Website: http://yojuan.com.ar
# Licence: GNU/GPL3

import os, random, datetime, time
####### COMANDOS DE SISTEMA GNU/LINUX-LIBRE USADOS ###########
def gnu_ls(execute):
	return os.system("ls -l "+str(execute))
def gnu_echo(execute):
	return os.system("echo "+str(execute))
def gnu_cp(dir_origin,dir_copy):
	return os.system("cp \""+str(dir_origin)+"\" \""+str(dir_copy)+"\"")
def gnu_dir(dir_origin):
	return os.system("dir \""+str(dir_origin)+"\"")
def gnu_mkdir(dir_origin):
	return os.system("mkdir -p \""+str(dir_origin)+"\"") #crea pre carpetas y sub si es necesario
def gnu_rm(dir_origin):
	ret = os.system("rm -r \""+str(dir_origin)+"\"") #devuelve 0 si remueve bien
	if ret!=0: #si no puede remover, reclusive
		ret = os.system("rm \""+str(dir_origin)+"\"")
	return ret
def gnu_tar(dir_origin,dir_tar): #problemas para archivos individuales (por esto la limitacion de solo carpetas)
	name,subdirs = search_text_name(dir_origin)
	return os.system("cd "+str(subdirs)+" && tar -zcf \""+str(dir_tar)+"\" \""+str(name)+"\"")
def gnu_notify(title,text,icon="",band=0,time=2000):
	if band==1:
		os.system("notify-send \""+str(title)+"\" \""+str(text)+"\" -t "+str(time)+" -i \""+str(icon)+"\"")
# ABRE UN NAVEGADOR
def gnu_nav_open(dir_origin):
	#declaramos lista de navegadores
	free = ["epiphany", "midori", "abrowser", "iceweasel", "arora", "konqueror"]
	other = ["seamonkey","firefox","netscape","safari", "aurora", "opera", "camino", "iceape","navigator", "minefield", "mlock", "icedove", "galeon", "shiretoko", "chromium", "chrome"]
	errdoc=1
	cont=0
	while cont<len(free):
		resp = os.system(free[cont]+" \"file://"+dir_origin+"\"")
		if resp==0:
			cont = len(free)
		cont+=1
	if resp!=0:
		cont=0
		while cont<len(other):
			resp = os.system(free[other]+" \"file://"+dir_origin+"\"")
			if resp==0:
				cont = len(free)
			cont+=1
	return resp
###### FIN COMANDO DE SISTEMAS #######
#AÑADE UN NUEVO FICHERO O CARPETA
def paranoia_add(dir_origin,name,dir_save):
	#si todo es valido
	resp = gnu_dir(dir_origin)
	if resp==0 and name!="":
			name = name.replace("/","-")
			dia = str(datetime.datetime.now().strftime("%d-%m-%Y %H:%M:%S")) #dd-mm-aaaa hh:mm:ss
			#guardamos en el fichero
			d=open(dir_save+"/row_saved","a")
			d.write(dia+"\n")
			d.write(str(name)+"\n")
			d.write(str(dir_origin)+"\n")				
			d.close()
			print "--\nADD!\nDATE:\n",dia,"\nNAME:",name,"\nFOLDER:",dir_origin,"--\n"
	else:
		print "\nCan't Add:",dir_origin
	return resp
#GUARDA BACKUPs
def paranoia_save(dir_backup,dir_save,max_copy,limit_max_size,limit_max_files,model,program_text,size_next_copy,free_disk):
	for row in model: #recorremos valores
			gnu_mkdir(dir_backup+"/"+row[1].replace("\n","")) #creamos directorio para backup
			act_open = dir_save+"/backup/"+row[1].replace("\n","") #archivo abierto actual
			try:
					s = open(act_open,"r") #vemos la cantidad y el numero actual de archivos obtenidos +1
					rread = s.readlines()
					cant = int(rread[0].replace("\n",""))+1
					s.close()
					#si es el maximo reiniciamos cantidad
					if cant>max_copy:
						cant=1
					max = int(len(rread)) #maximo (se usa pra reescribir datos)
			except: 
					#si no existe escribimos datos por primera vez
					s = open(act_open,"w").close()
					cant=1
					max=1
					rread = [cant,str(dir_backup)+"/"+row[1].replace("\n","")+"/"+str(cant)]

			text,size_next_copy,key_copy,ant,it_add = paranoia_analyze_copy(dir_save,dir_backup,program_text,row[1],row[2],limit_max_size,limit_max_files,free_disk,size_next_copy)
			if it_add!=0:
				key_copy=0
			saved = dir_backup+"/"+row[1]+"/"+str(cant)+".tgz"
			#SI SE PERMITE COPIAR
			if key_copy==1:
					print "\n--> Save Backup..."
					result = gnu_tar(row[2],saved)  #comando de sistema
					if result == 0:
						print "--> It is Save:",saved
						diahora = str(datetime.datetime.now().strftime("%d-%m-%Y %H:%M:%S")) #dd-mm-aaaa hh:mmm:ss	
						#REESCRIBIMOS DATOS GUARDADOS
						s = open(dir_save+"/backup/"+row[1].replace("\n",""),"w")
						s.write(str(cant)+"\n")
						cont=2		
						is_max=(max_copy*2)+1 #el maximo es la cntidad de x renglones + 1						
						while cont<max:  #reescribimos todos nuevamente
							if str(rread[cont]).replace("\n","") != str(saved).replace("\n",""): #escribimos solo si son distintos
								s.write(rread[cont-1])
								s.write(rread[cont])							
							cont+=2
						#escribimos el dato actual
						s.write(diahora+"\n")
						s.write(saved+"\n")
						s.close()
					else:
						print "--> Can't Save :-( ",saved
			#SI NO EXISTE ARCHIVO DE BACKUP ANTERIOR
			elif ant==2:
						#ELIMINAMOS LA ULTIMA FILA (PORQUE NO EXISTE)
						w = open(dir_save+"/backup/"+row[1].replace("\n",""),"w")
						num = w.readline().replace("\n","")
						num = int(num)-2
						w.lose()
						w.write(str(cant-1)+"\n")
						cont=2
						while cont < max-2:
							w.write(rread[cont-1])
							w.write(rread[cont])
							cont+=2
						w.close()
			#SI NO EXISTE CARPETA DE ORIGEN
			elif ant==3:
					print "\nFolder does not exist! :-("	
#TAMAÑO DE COPIA
def paranoia_analyze_copy(dir_save,dir_backup,program_text,num,dir_origin,limit_max_size,limit_max_files,free_disk,size_next_copy=0.0,key_copy=0,ant=0):
		text = ""
		it_add=0 #si se mantiene en 0 se añade
		act_open = dir_save+"/backup/"+str(num) #archivo abierto actual
		try:
			#vemos la cantidad y el numero actual de archivos obtenidos +1
			s = open(act_open,"r")
			rread = s.readlines()
			cant = int(rread[0].replace("\n",""))+1
			s.close()
			max = int(len(rread)) #maximo (se usa pra reescribir datos)
		except: 
			#si no existe escribimos datos por primera vez
			s = open(act_open,"w").close()
			cant=1
			max=1
			rread = [cant,str(dir_backup)+"/"+str(num)+"/"+str(cant)]
		#verificamos que este directorio		
		resp = gnu_dir(dir_origin)
		print "\n",dir_origin+":"
		if resp == 0: #si se encuentra directorio para copiar
				key_copy=0
				prev_saved = 0 #guardado anterior pre definido fecha 0
				#VERIFICAMOS SI HAY ALMENOS UN ARCHIVO ANTERIOR 
				if cant>1 and max>1:
					ant=1
					#obtenemos fecha de ultima modificacion de ultmo archivo copiado
					tmp = rread[max-1].replace("\n","")
					rsp=gnu_dir(tmp)
					if rsp!=0:
						#EL RESPALDO SOLISITADO NO EXISTE
						ant=2
					else:
						prev_saved = os.path.getmtime(tmp)
				#SI SE PERMITE, RECORREMOS DIRECTORIOS Y CALCULAMOS TAMAÑO
				if ant!=2:
					tmp_size = 0 #guardmos tamaño en variable tmp
					#buscamos modificaciones en sub carpetas
					for path, dirs, files in os.walk(dir_origin):
						tmp_cant=0
						for f in files:
							act_saved = path+"/"+f #tomamos tamaño
							tmp_size+=os.path.getsize(act_saved)
							tmp_cant+=1
							if os.path.getmtime(act_saved) > prev_saved: #si se copia por ser mas nuev obtenemos tamaño
								key_copy=1 #permiso de copiar
						#REVISAMOS EL LIMITE DE PESO Y LIMITE DE ARCHIVOS
						if tmp_size > (limit_max_size*1024)*1024: #si la carpeta excede el limite
							it_add=2
							tmp_size=0 #volvemos tamaño a 0
							break; #si excede sale del bucke			
						elif tmp_cant > limit_max_files:
							it_add=3
							tmp_size=0 #volvemos tamaño a 0
							break; #si excede sale del bucke		
						for d in dirs: #suma carpetas y revisa fechas
							act_saved = path+"/"+d
							tmp_size+=os.path.getsize(act_saved)
					if key_copy==1:
						#si hay resultado pasamos el tamaño a size
						size_next_copy+=tmp_size
					#ACTUALIzAMOS EL TAMAÑO DE LA PROXIMA COPIA Y DISCO
					if size_next_copy > free_disk:
							print "\nthere is not enough disk space\n"
							#no hay espacio, sacamos permiso de copiar
							key_copy=0
							text = "<span color='#f12'><b>"+program_text[79]+"</b></span>"
					else:
							print "\nThere is space, you can protect\n"
							#hay espacio
							text = "<span color='#5B3'><b>"+program_text[78]+"</b></span>"
		else:
			#INDICA QUE EL DIRECTORIO NO EXISTE
			print "\n-- DIRECTORY DOES NOT EXIST!...\n"
			ant=3 #se trata de recuperar
		return text,size_next_copy,key_copy,ant,it_add
#COMPRUEBA Y GUARDA DISPOSITIVOS
def paranoia_device_save(dir_backup,dir_save,model,uuidfolder):
	uuids,devices,labeld = paranoia_device_check() #dispositivos
	try:
		print "\n--> READ DEVICE..."
		f = open(str(dir_save)+"/row_uuid_save","r")
		save_in_uuid = f.readlines()
		f.close()

		for row in model:
				act_open = dir_save+"/backup/"+row[1].replace("\n","") #archivo abierto actual
				
				s = open(act_open,"r")
				rread = s.readlines()
				cant = int(rread[0].replace("\n",""))
				s.close()
				
				saved = dir_backup+"/"+row[1]+"/"+str(cant)+".tgz"
				cont=1
				while cont<len(save_in_uuid):
					print "\n--> DEVICE -->",save_in_uuid[cont-1].replace("\n","")," --> UUID -->",save_in_uuid[cont].replace("\n","")
					devicee = paranoia_uuid_check(save_in_uuid[cont],uuids,devices,labeld,uuidfolder)
					if devicee!=None:
						key_copy=1
						devicee = str(devicee).replace("\n","")+uuidfolder+"/"+str(row[1])+".tgz"
						print "--> MAKING A COPY AS",devicee
						resp = gnu_dir(devicee)
						if resp==0:
							if os.path.getmtime(devicee)>=os.path.getmtime(saved):
								key_copy=0
								print "--> NO NEED TO COPY..."
						if key_copy==1:
							resp = gnu_cp(saved,devicee)
							if resp!=0:
								print "--> COULD NOT SAVE ... WRITING NO PERMITS"
					cont+=2
	except:
		save_in_uuid=""
		print "\n--> NO ADDED DEVICES or COPIES"	

#OBTIENE ETIQUETA Y DEDUCE AUTOMONTAJE DE DISPOSITIVO...
def paranoia_uuid_check(selected,uuids,devices,labeld,uuidfolder):
	print "--> SEARCH",selected.replace("\n","")
	cont=0;dr=None;
	for tmp in uuids:
		if tmp!=None:
			print "-->",str(tmp).replace("\n","")
			if str(tmp).replace("\n","") == str(selected).replace("\n",""):
				dr = "/media/"+str(labeld[cont]).replace("\n","")+"/"
				ret = os.system("cd "+dr)
				if ret!=0:
					dr = "/mnt/"+str(labeld[cont]).replace("\n","")+"/"
					print "-->",dr
					ret = os.system("cd "+dr)
					if ret==0:
						gnu_mkdir(dr+str(uuidfolder))
					else:
						dr=None
						print selected,"--> CAN'T FIND!"
				else:
					gnu_mkdir(dr+str(uuidfolder))
		cont+=1
	return dr
#OBTIENE UUID DE DISPOSITVOS, ETIQUETA Y NUMERO
def paranoia_device_check(selected=""):
	#leemos dispositivos por uuid
	try:
		gnu_ls("/dev/disk/by-uuid > /tmp/%uuid%")
		a = open("/tmp/%uuid%","r")
		tmp = a.read()
		a.close()
	except:
		print "ERROR!, ls -l /dev/disk/by-uuid and SAVE /tmp"
		exit(1)
	cont=0;save_r=0;l=0;
	list_uuid = [None,None,None,None,None,None,None,None,None,None,None,None,None,None,None]
	list_device = [None,None,None,None,None,None,None,None,None,None,None,None,None,None,None]
	uuiddevice=""
	#recorremos el archivo y buscamos el uuid y dispositivo
	while cont<len(tmp):
		if tmp[cont]==":":
			cont+=3
			save_r=1
		elif save_r==1:
			if tmp[cont]!=">":
				uuiddevice+=str(tmp[cont])
			else:
				list_uuid[l] = uuiddevice.replace(" -","")
				uuiddevice=""
				save_r=2
		elif save_r==2:
			if tmp[cont]!="\n":
				uuiddevice+=str(tmp[cont])
			else:
				list_device[l] = uuiddevice.replace(" ../../","/dev/")
				uuiddevice=""
				save_r=0
				l+=1
		cont+=1
	#leemos dispositivos label
	try:
		gnu_ls("/dev/disk/by-label > /tmp/%label%")
		a = open("/tmp/%label%","r")
		tmp = a.read()
		a.close()
	except:
		print "ERROR!, ls -l /dev/disk/by-label and SAVE /tmp"
		exit(2)
	cont=0;save_r=0;l=0;
	labeld_list = [None,None,None,None,None,None,None,None,None,None,None,None,None,None,None]
	label_device = [None,None,None,None,None,None,None,None,None,None,None,None,None,None,None]
	labeldevice=""		
	while cont<len(tmp): #buscamos labeles
		if tmp[cont]==":":
			cont+=3
			save_r=1
		elif save_r==1:
			if tmp[cont]!=">":
				labeldevice+=str(tmp[cont])
			else:
				labeld_list[l] = labeldevice.replace(" -","")
				labeldevice=""
				save_r=2
		elif save_r==2:
			if tmp[cont]!="\n":
				labeldevice+=str(tmp[cont])
			else:
				label_device[l] = labeldevice.replace(" ../../","/dev/")
				labeldevice=""
				save_r=0
				l+=1
		cont+=1		
	#compara la lista de dispositivo; uuid con la de label y acomodamos para mostrar etiquetas correctamente
	list_label=labeld_list;l=0;
	for read in label_device:
		cont=0
		for comp in list_device:
			if comp!=None:
				if comp == read: #guarda en list_label con pocicion de list_device (para que coincida)
					list_label[cont]=str(labeld_list[l])
			cont+=1
		l+=1
	try:
		a = open("/etc/fstab","r")
		tmp = a.read()
		a.close()
	except:
		print "ERRO!, in read /etc/fstab"
		exit(1)
	#saca dispositivos montados por defectos en /etc/fstab
	mountes=[None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None]
	cont=0;save_r=0;
	l=0
	uuiddevice=""
	#recorre el archivo y buscamos el uuid o numero de dispositivo
	while cont<len(tmp):
		if tmp[cont]!="#":
			if (tmp[cont]=="=" or tmp[cont]=="/") and save_r==0:
				save_r=1
			if save_r==1:
				if tmp[cont]!=" ":
					uuiddevice+=str(tmp[cont])
				else:
					mountes[l] = uuiddevice.replace("=","")
					uuiddevice=""
					save_r=2
					l+=1
			elif save_r==2:
				if tmp[cont]=="\n":
					save_r=0
		cont+=1
	#comparamos valores y colocamos "None" a los montados por defecto o ya seleccionados...
	for comp in mountes:
		cont=0
		for read in list_uuid:
				if read!=None:
					if read==comp:
						print read
						list_device[cont]=None
						list_uuid[cont]=None
						list_label[cont]=None
				cont+=1
		cont=0
		for read in list_device:
				if read!=None:
					if read==comp:
						print read
						list_device[cont]=None
						list_uuid[cont]=None
						list_label[cont]=None
					#si es ram no mostramos
					r = str(list_device[cont]).find("/dev/zram")
					if r>=0:
						list_device[cont]=None
						list_uuid[cont]=None
						list_label[cont]=None
				cont+=1
	#dispositivos ya seleccionados como None
	for comp in selected:
		if selected!="":
			cont=0
			for read in list_uuid:
				if read!=None:
					if str(read).replace("\n","")==str(comp).replace("\n",""):
						list_device[cont]=None
						list_uuid[cont]=None
						list_label[cont]=None
				cont+=1
				
	return list_uuid,list_device,list_label
#CONVIERTE Y TRUNCA DATOS (ENTERO/FLOAT)
def paranoia_dat_t(dat):
		dat = (dat/1024)/1024
		if dat<1024: #si es menos de 1024mb truncamos decimales
			dat = float(str(dat)[0:6])
		else:
			dat = int(dat)
		return dat
#LA FUNCION DEVUELVE EL NOMBRE DE UNA DIRECCION DESPUES DE LA ULTIMA /
def search_text_name(text):
	if text == "/":
		name="/"
	else:
		#buscamos texto despues de la ultima /
		start=0
		#contamos cantidad de "/"
		for search in text:
			if search == "/":
				#cantidad de "/"				
				start+=1 
		search=0;name="";subdirs="";
		for look in text: 
			#buscamos "/"
			if look=="/":
				subdirs+="/"
				search+=1
			elif search>=start: 
				#despues de la ultima agregamos nombre
				name+=str(look)
			else:
				subdirs+=str(look)
	return name,subdirs
#REMOVE BACKUPS
def paranoia_remove_backups(dir_save,dir_backup,name):			
	#rm remueve directorios o archivos
	os.remove(str(dir_save)+"/backup/"+str(name))
	gnu_rm(str(dir_backup)+"/"+str(name))		
	print "--> ELIMINED:"+str(name)
#SAVE DATA
def program_save(dir_save,init_minimize,repeat,time_copy,max_copy,limit_max_size,limit_max_files,notify_active,start_system,select_language,dir_restore,dir_backup,uuidfolder):
	#escribimos la bandera status y de ver (pshow) para recordar estados
	s=open(dir_save+"/preference","w")
	s.write(str(init_minimize)+"\n")
	s.write(str(repeat)+"\n")
	s.write(str(time_copy)+"\n")
	s.write(str(max_copy)+"\n")
	s.write(str(limit_max_size)+"\n")
	s.write(str(limit_max_files)+"\n")
	s.write(str(notify_active)+"\n")
	s.write(str(start_system)+"\n")
	s.write(str(select_language)+"\n")
	s.write(str(dir_restore)+"\n")
	s.write(str(dir_backup)+"\n")
	s.write(str(uuidfolder)+"\n")
	s.close()
#CARGA DATOS DEL PROGRAMA
def program_load(dir_save,dir_home):
	try: 
			x=open(dir_save+"/preference","r")
			tmp = x.readlines()
			x.close()
			init_minimize = int(tmp[0].replace("\n",""))
			repeat = int(tmp[1].replace("\n",""))
			time_copy = int(tmp[2].replace("\n",""))
			max_copy = int(tmp[3].replace("\n",""))
			limit_max_size= int(tmp[4].replace("\n",""))
			limit_max_files= int(tmp[5].replace("\n",""))
			notify_active = int(tmp[6].replace("\n",""))
			start_system = int(tmp[7].replace("\n",""))
			select_language = str(tmp[8].replace("\n",""))
			dir_restore = str(tmp[9].replace("\n",""))
			dir_backup = str(tmp[10].replace("\n",""))
			uuidfolder = str(tmp[11].replace("\n",""))
			if gnu_dir(dir_backup) != 0:
				print "\n--> Insufficient authority in",dir_backup
				exit(1)
			first=0
	except: #PRIMERA CARGA
			first=1
			init_minimize=0
			repeat=1000
			time_copy=60
			max_copy=2
			limit_max_size=2048 #maximo peso para añadir en mb(2gb)
			limit_max_files=1000 #maxima cantidad de archivos
			notify_active=1
			start_system=0
			select_language = "español"
			dir_restore = dir_home
			dir_backup = dir_home+"/.paranoia_backup"
			uuidfolder = "000-paranoia_auto-backup"
			resp = gnu_mkdir(dir_backup)
			if resp!=0: # NO PUEDE CRRAR EN HOME EL DIR DE BACKUP
				print "\nERROR!, Insufficient authority in:",dir_home+"/.paranoia_backup"
				exit(1)
			program_save(dir_save,init_minimize,repeat,time_copy,max_copy,limit_max_size,limit_max_files,notify_active,start_system,select_language,dir_restore,dir_backup,uuidfolder)
	
	return first,init_minimize,repeat,time_copy,max_copy,limit_max_size,limit_max_files,notify_active,start_system,select_language,dir_restore,dir_backup,uuidfolder
#CARGA IDIOMAS (language)
def program_language_load(gnu_share):
	try:
		s = open(gnu_share+"paranoia/language/language","r")
		languages = s.readlines()
		cont=0
		for text in languages:
			languages[cont] = text.replace("\n","")
			cont+=1
		s.close()
	except:
		print "LANGUAGE CORRUPTED!"
		exit(2)
	return languages
#CARGA TEXTO PARA MOSTRAR
def program_text_load(select_language,gnu_share):
	try:
		l=open(gnu_share+"/paranoia/language/"+str(select_language),"r")
		program_text = l.readlines() #texto a mostrar
		program_text[147] #en el archivo deve haber 144 lineas (0-143)	
		cont=0; #se usa para dar pociciones en un diccionario a los datos text
		for text in program_text:
			if cont>8:
				program_text[cont-9] = text.replace("\n","") #sacamos los "enter"
			cont+=1
		l.close()
	except:
		print "\nERROR to load \""+str(select_language)+"\", corrupted!"
		exit(1)
	return program_text
#LEE Y CREA CARPETAS PARA EL PROGAMA
def paranoia_auto_directory():
	#CREAMOS UN ARCHIVO DONDE GUARDAMOS LA DIRECCION DE HOME
	resp = gnu_echo("$HOME > /tmp/%dir%")
	if resp == 0:
		l=open("/tmp/%dir%","r")
	else:
		resp = gnu_echo("$HOME > %dir%")
		if resp != 0:
			print "\nERROR, Can't read the user folder\nCheck permissions on /tmp or run as root"
			exit(1)
		l=open("%dir%","r")
	#GUARDAMOS LAS DIRECCIONES EN VARIABLES
	dir_home = l.readline().replace("\n","")
	l.close()
	dir_save = dir_home+"/.config/"
	resp=gnu_mkdir(dir_save)
	#REVISION DE PERMISOS
	if resp == 0:
		dir_save = dir_home+"/.config/paranoia-auto-backup"
		resp = gnu_mkdir(dir_save+"/backup/")
		if resp != 0:
			print "\nERROR!, Insufficient authority in:",dir_save
			exit(1)
	else:
		print "\nERROR!, Insufficient authority in:",dir_save
		exit(1)
	#BORRAMOS ARCHIVO CREADO
	resp = gnu_rm("/tmp/%dir%")
	if resp!=0:
		gnu_rm("%dir%")
	#devolvemos directorio donde guardar, directorio home
	return dir_save,dir_home
